【解题报告】 HDU - 1540 Tunnel Warfare(区间更新区间维护线段树、树状数组的二分运用)

原题链接——HDU
原题链接——poj

题意

开始的时候有n个村庄相互联通,然后有m条命令,每条命令可以进行如下操作:

  1. 摧毁一个村庄
  2. 修复一个村庄
  3. 询问与第x个村庄相互联通的现存的村庄最多有多少个

对于已经摧毁的村庄,即算作一个断点,其左右相邻的村庄不再联通。对于每一次询问操作,输出最大的联通村庄数目。

思路

这道题目因为是单点更新单点询问,让人很容易能想到要用树状数组去维护前缀和,但是询问最大联通数量的时候不能单纯的用前缀和相减得到,所以我们想到去二分答案,满足的条件为两点的前缀和相差正好为两点的位置差,于是要先找到询问村庄x的左边第一个满足条件的点,然后再找到x的右边最后一个满足条件的点,这里的二分可以直接套用之前记下的板子求第一个和最后一个满足条件的点,但是
要注意细节,即二分的范围,我们要搜索左边时应该要把左区间开到0,这样如果左边都满足条件记录的就是0,最后两区间相减得答案的时候就不用-1,同理,右边区间开到n+1。

代码:

//#include <bits/stdc++.h>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <vector>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stack>
#define inf 0x3f3f3f3f
#define dbg cout << "!!!" << endl
//#define Local
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const static int maxn = 50000+10;

int n, m;
int sum[maxn];

int lowbit(int x)
{
    return x & (-x);
}

void add(int x, int c)
{
    for(int i=x; i<=n; i += lowbit(i))
    {
        sum[i] += c;
    }
}

int query(int x)
{
    int res = 0;
    for(int i=x; i>0; i -= lowbit(i))
    {
        res += sum[i];
    }
    return res;
}

bool check(int left, int right)
{
    if(query(right) - query(left) == right - left)
        return true;
    return false;
}

int main()
{
#ifdef Local
    freopen("1.in", "r", stdin);
    freopen("1.out", "w", stdout);
#endif
    while(scanf("%d %d", &n, &m) != EOF)
    {
        memset(sum, 0, sizeof(sum));
        for(int i=1; i<=n; i++)
        {
            add(i, 1);
        }
        int top = 0;
        int STACK[maxn];
        for(int i=1; i<=m; i++)
        {
            char cmd[10];
            scanf("%s", cmd);
            if(cmd[0] == 'D')
            {
                int pos;
                scanf("%d", &pos);
                add(pos, -1);
                STACK[++top] = pos;
            }
            else if(cmd[0] == 'Q')
            {
                int cur, l, r, ans, rs = -1, re = -1;
                scanf("%d", &cur);
                //printf("%d\n", query(cur));
                if(query(cur) - query(cur-1) == 0)//询问的村庄被destroy了
                {
                    printf("0\n");
                    continue;
                }
                //二分搜索
                l = 0, r = cur+1;
                while(l < r)
                {
                    int mid = (l + r)>>1;
                    //cout<<mid<<" "<<query(cur)<<"|"<<query(mid)<<endl;
                    if(check(mid, cur))
                    {
                        r = mid;
                    }
                    else
                    {
                        l = mid+1;
                    }
                    rs = l;
                }
                l = cur, r = n+1;
                while(l < r)
                {
                    int mid = (l + r + 1)>>1;
                    //cout<<mid<<query(cur)<<"|"<<query(mid)<<endl;
                    if(check(cur, mid))
                    {
                        l = mid;
                    }
                    else
                    {
                        r = mid - 1;
                    }
                    re = l;
                }
                //cout<<"!!"<<rs<<" "<<re<<endl;
                cout<<re - rs<<endl;
            }
            else if(cmd[0] == 'R')
            {
                if(top == 0)
                    continue;
                int pos = STACK[top--];
                add(pos, 1);
            }
        }
    }
} 

俗话说,能用树状数组解决的问题都可以用线段树解决 ,但这个线段树的代码量是真的大啊。思路其实很好理解,我们需要用维护一个区间的最大连续区间长度、左端最大连续区间长度和右端连续区间长度,然后更新和询问时对不同的情况做出判断就行了,思想和代码的整体框架还是线段树那个味道。
其余的要点都写在注释里了:

//#include <bits/stdc++.h>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <vector>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stack>
#define inf 0x3f3f3f3f
#define dbg cout << "!!!" << endl
//#define Local
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const static int maxn = 50000+10;

int n, m;
int _stack[maxn];
//线段树写成结构体的形式,下标表示根节点编号
struct segmentree
{
    int l, r;
    int ls, rs, ms;
}st[maxn*4];

void buildtree(int l, int r, int rt)
{
    st[rt].l = l;
    st[rt].r = r;
    st[rt].ls = st[rt].rs = st[rt].ms = r - l + 1;
    if(l == r)
        return;
    int mid = (l + r) >> 1;
    buildtree(l , mid, rt<<1);
    buildtree(mid+1, r, rt<<1|1);
}

void update(int x, int rt, int v)
{
    if(st[rt].l == st[rt].r)
    {
        st[rt].ms  = st[rt].ls = st[rt].rs = v;
        return;
    }
    int mid = (st[rt].l + st[rt].r)>>1;
    if(x <= mid)
        update(x, rt<<1, v);
    else
        update(x, rt<<1|1, v);
    //pushup()的内容
    if(st[rt<<1].ls == st[rt<<1].r - st[rt<<1].l + 1)//左儿子区间是连续的
        st[rt].ls = st[rt<<1].ls + st[rt<<1|1].ls;
    else
        st[rt].ls = st[rt<<1].ls;
    if(st[rt<<1|1].rs == st[rt<<1|1].r - st[rt<<1|1].l + 1)
        st[rt].rs = st[rt<<1|1].rs + st[rt<<1].rs;
    else
        st[rt].rs = st[rt<<1|1].rs;
    //该节点的最大连续区间长度等于左儿子的最大区间长、右儿子最大区间长和自身的左边最大连续区间长与右边最大连续区间长之和
    st[rt].ms = max(max(st[rt<<1].ms, st[rt<<1|1].ms), st[rt<<1].rs + st[rt<<1|1].ls);
}

int query(int x, int rt)
{
    //递归到叶子节点或者区间的村庄都被破坏或者整个区间都连续则返回。
    if(st[rt].ms == 0 || st[rt].l == st[rt].r || st[rt].ms == st[rt].r - st[rt].l + 1)
    {
        return st[rt].ms;
    }
    int mid = (st[rt].r + st[rt].l)>>1;
    if(x <= mid)
    {
        if(x >= st[rt<<1].r - st[rt<<1].rs + 1)//x在该区间的左边的连续区间里
            return st[rt<<1].rs+st[rt<<1|1].ls;
        else
        {
            return query(x, rt<<1);
        }
    }
    else
    {
        if(x <= st[rt<<1|1].l + st[rt<<1|1].ls - 1)
            return st[rt<<1].rs+st[rt<<1|1].ls;
        else
        {
            return query(x, rt<<1|1);
        }
    }
}

int main()
{
#ifdef Local
    freopen("1.in", "r", stdin);
    freopen("1.out", "w", stdout);
#endif
    while(scanf("%d %d", &n, &m) != EOF)
    {
        int top = 0;
        buildtree(1, n, 1);
        while(m--)
        {
            char cmd[10];
            scanf("%s", cmd);
            if(cmd[0] == 'D')
            {
                int x;
                scanf("%d", &x);
                _stack[top++] = x;
                update(x, 1, 0);
            }
            else if(cmd[0] == 'Q')
            {
                int x;
                scanf("%d", &x);
                printf("%d\n", query(x, 1));
            }
            else
            {
                if(top)
                {
                    int x = _stack[--top];
                    update(x, 1, 1);
                }
            }
        }
    }
} 
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值